require 'sketchup.rb'
###
module TIG
### scales a selected face about its center to a new area, in current units.
   def self.scale_face()
      model=Sketchup.active_model
      es=model.active_entities
      ss=model.selection
      fa=nil
      fa=ss[0] if ss[0]
      unless fa && fa.is_a?(Sketchup::Face)
         UI.messagebox("Scale_Face:\n\nPreSelect ONE FACE !")
         return nil
      end
      ar=fa.area
      mo=model.options["UnitsOptions"]
      if mo["LengthUnit"] > 1 ### metric
         units="m"
         ar=ar*25.4*25.4/1000/1000
      else ### ft/"
         units="ft"
         ar=ar/12.0/12.0
      end
      rs=inputbox(["New Area [sq "+units+"]:        "], [ar], "Scale_Face")
      return nil unless rs
      na= rs[0]
      na= -na if na < 0
      unless na>0
         UI.beep
         return nil
      end
      ro=Math.sqrt(na/ar)
      pt=fa.bounds.center
      tr=Geom::Transformation.scaling(pt, ro)
     model.start_operation("Scale_Face")
      es.transform_entities(tr, fa.vertices)
     model.commit_operation
   end
   ###
   UI.menu("Plugins").add_item("Scale_Face"){self.scale_face()} unless file_loaded?(__FILE__)
   file_loaded(__FILE__)
   ###
end
###